from Bio.Seq import Seq

class MySeq(Seq):
    def __init__(self, seq, conf):
        Seq.__init__(self, seq)
        self.confidence = conf  # confidence values

    # Seq doesn't compute GC content so 
    # we'll add that functionality
    def gc_content(self):
        return len([b for b in self if b in "GC"]) / len(self)
    
    def avg_confidence(self):
        return sum(self.confidence)/len(self.confidence)

seq1 = Seq("ACGTATG")
seq2 = MySeq("AAACG",[0.9, 0.8, 0.5, 1, 0.8]) 
print("GC content = ",seq2.gc_content())
print("Average confidence value = ", seq2.avg_confidence())
