# YOUR NAME
# YOUR MCGILL ID NUMBER

def symptom_similarity(my_symptoms, other_symptoms):
    """
    Args:
        my_symptoms: tuple of a set of symptoms present and a set of symptoms absent
        other_symptoms: tuple of a set of symptoms present and set symptoms absent
    Returns:
        common_present + common_absent - common_present_absent - common_absent_present
        where common_present is the number of symptoms present in both patients
        common_absent is the number of symptoms absent in both patients
        common_present_absent is the number of symptoms present in my_patient and absent          
        in other_patient
        common_absent_present is the number of symptoms absent in my_patient and present         
        in other_patient
    """
    # WRITE YOUR CODE HERE
   

def similarity_to_patients(my_symptoms, all_patients):
    """
    Args:
        my_symptoms: tuple of symptoms present and absent
        all_patients: dictionary of patients IDs (key) and associated tuple of
                      present and absent symptoms
    Returns:
        List of tuples of the form: (patientID, similarity), sorted by the similarity
        between my_symptoms and the symptoms of each patient in all_patients.
     """    
    # WRITE YOUR CODE HERE

def most_similar_patients(my_symptoms, all_patients, n_top):
    """
    Args:
        my_symptoms: tuple of a set of symptoms present and absent
        all_patients: dictionary of patients IDs (key) and associated tuple of
                      present and absent symptoms
        n_top: Maximum number of patients to return
    Returns:
        The set of up to n_top patient IDs from all_patients 
        with the highest similarity to my_symptoms
    """ 
    # WRITE YOUR CODE HERE

def count_diagnostics(patient_set, diagnostic_by_patient):
    """
    Args:
        patient_set: A set of patient IDs
        diagnostic_by_patient: A dictionary with key = patient_ID and values = diseases
    Returns:
        A dictionary with keys = diagnostic and 
        values = fraction of patients in patient_set with that diagnostic
    """     
    # WRITE YOUR CODE HERE

def diagnostics_from_symptoms(my_symptoms, all_patients_symptoms, all_patients_diagnostics, n_top):
    """
    Args:
        my_symptoms: tuple of symptoms present and absent
        all_patients_symptoms: dictionary of patients IDs (key) and associated symptoms
        all_patients_diagnostics: dictionary of patients IDs (key) and associated diagnostic
        n_top: Number of most similar patients to consider.
    Returns:
        A dictionary with keys = diagnostic and 
        values = fraction of the n_top most similar patients with that diagnostic
  """
    # WRITE YOUR CODE HERE


def pretty_print_diagnostics(diagnostic_freq):
    """
    Args:
        diagnostic_freq: A dictionary with key = diagnostic and value = frequency
    Returns:
        Nothing
    Prints:
        A table of possible diagnostics, sorted by frequency, expressed as percentages. 
        Only diagnostics with non-zero percentages should be printed.
        If a diagnostic is longer than 10 characters, it should be truncated to 10 characters.
        Frequencies should be expressed as percentages, rounded to the nearest percent.
    """     
    # WRITE YOUR CODE HERE


def recommend_symptom_to_test(my_symptoms, all_patients_symptoms, all_patients_diagnostics, n_top):
    """
    Args:
        my_symptoms: tuple of symptoms present and absent
        all_patients_symptoms: dictionary of patients IDs (key) and associated symptoms
        all_patients_diagnostics: dictionary of patients IDs (key) and associated diagnostic
        n_top: Number of most similar patients to consider.
    Returns:
        A string describing the best symptom to test for in order to clarify the diagnostic.
    Explanation:
        The best symptom to test for is one that: 
        (i) has been tested at least once among the patients in all_patients_symptoms
        (ii) is not already in the new_patient_symptoms, and 
        (iii) yields the maximum value (see text of question for definition of value). 
    """
    # WRITE YOUR CODE HERE
                


# This function is provided to you. You do not need to modify it.
def read_data_from_file(filename):
    """
    args:
        filename: Name of file containing medical data
    Returns:
        Tuple of a dictionary of symptoms and a dictionary of diagnostics
    """
    
    f = open(filename,'r')
    lines = f.read().splitlines()
    
    i =0
    symptoms_by_patient={}
    diagnostic_by_patient={}
    l=len(lines)
    while i<l:
        ID=int(lines[i].split()[0])
        present = lines[i+1].split()
        absent = lines[i+2].split()
        diag = lines[i+3].split()[0]
        symptoms_by_patient[ID]=(present,absent)
        diagnostic_by_patient[ID]=diag
        i += 4
        
    return symptoms_by_patient, diagnostic_by_patient


def my_test():
    """ This function is used to test the other functions.
        Its expected output is contained in the file my_test_output.txt
        It will not be graded. We provided it to let you make sure
        that your own functions work properly.
    """
    
    # A small dictionary of patient's symptoms
    all_patients_symptoms = {56374: ({"headache","fever"}, {"coughing", "runny_nose","sneezing"}),
                           45437: ({"coughing", "runny_nose"},{"headache","fever"}),
                           16372: ({"coughing", "sore_throat"},{"fever"}),
                           54324: ({"vomiting", "coughing","stomach_pain"},{"fever"}),
                           35249: ({"sore_throat", "coughing","fever"},{"stomach_pain", "runny_nose"}),
                           44274: ({"fever", "headache"},{"stomach_pain", "runny_nose","sore_throat", "coughing",}), 
                           74821: ({"vomiting", "fever"},{"headache"}),
                           94231: ({"stomach_pain", "fever","sore_throat","coughing","headache"},{"vomiting"}),
                           }
    # A small dictionary of patient's diagnostics                  
    all_patients_diagnostics = {45437: "cold", 56374:"meningitis", 54324:"food_poisoning", 
                             16372:"cold", 35249:"pharyngitis", 44274:"meningitis", 
                             74821:"food_poisoning", 94231:"unknown"}
    
    
    # Thre test patients
    yang = ({"coughing", "runny_nose", "sneezing"},{"headache","fever"})
    #  maria = ({"coughing", "fever", "sore_throat", "sneezing"},{"sneezing","muscle_pain"})
    maria = ({"coughing", "fever", "sore_throat", "sneezing"},{"muscle_pain"})
    jaspal = ({"headache"},{"sneezing"})
    
    # Testing the symptom_similarity function
    print("*"*80)
    sim = symptom_similarity(yang, maria)
    print("The similarity between Yang and Maria is",sim)
    sim = symptom_similarity(yang, jaspal)
    print("The similarity between Yang and Jaspal is",sim)
    sim = symptom_similarity(maria, jaspal)
    print("The similarity between Maria and Jaspal is",sim)
    
    # Testing the similarity_to_patients function
    print("*"*80)    
    sim_list = similarity_to_patients(yang, all_patients_symptoms)
    print("similarity list for Yang is ",sim_list)
    sim_list = similarity_to_patients(maria, all_patients_symptoms)
    print("Similarity list for Maria is ",sim_list)
    sim_list = similarity_to_patients(jaspal, all_patients_symptoms)
    print("Similarity list for Jaspal is ",sim_list)
    
    # Testing the most_similar_patients function
    print("*"*80)
    best_matches_yang = most_similar_patients(yang, all_patients_symptoms,4)
    print("Yang's best matches:",best_matches_yang)
    best_matches_maria = most_similar_patients(maria, all_patients_symptoms,4)
    print("Maria's best matches:",best_matches_maria)
    best_matches_jaspal = most_similar_patients(jaspal, all_patients_symptoms,4)
    print("Jaspal's best matches:",best_matches_jaspal)
    
    # Testing the count_diagnostics function
    print("*"*80)
    diagnostics_yang = count_diagnostics({16372, 45437, 54324}, all_patients_diagnostics)
    print("Diagnostics for Yang:", diagnostics_yang)
    diagnostics_maria = count_diagnostics({35249, 16372, 74821, 94231}, all_patients_diagnostics)
    print("Diagnostics for Maria:", diagnostics_maria)
    diagnostics_jaspal = count_diagnostics({44274, 56374}, all_patients_diagnostics)
    print("Diagnostics for Jaspal:", diagnostics_jaspal)
    
    # Testing the diagnostics_from_symptoms function
    print("*"*80)    
    diagnostics_yang = diagnostics_from_symptoms(yang, all_patients_symptoms, all_patients_diagnostics, 4)
    print("Diagnostics for Yang:", diagnostics_yang)
    diagnostics_maria = diagnostics_from_symptoms(maria, all_patients_symptoms, all_patients_diagnostics, 4)
    print("Diagnostics for Maria:",diagnostics_maria)
    diagnostics_jaspal = diagnostics_from_symptoms(jaspal, all_patients_symptoms, all_patients_diagnostics, 4)
    print("Diagnostics for Jaspal:",diagnostics_jaspal)
    
    # Testing the pretty_print_diagnostics function
    print("*"*80)
    print("Patient Yang:")
    pretty_print_diagnostics(diagnostics_yang)
    print("Patient Maria:")
    pretty_print_diagnostics(diagnostics_maria)
    print("Patient Jaspal:")
    pretty_print_diagnostics(diagnostics_jaspal)
    
    # Testing the recommend_symptom_to_test function
    print("*"*80)
    rec_yang = recommend_symptom_to_test(yang, all_patients_symptoms, all_patients_diagnostics, 4)
    print("Recommended symptom to test for Yang:",rec_yang)
    rec_maria = recommend_symptom_to_test(maria,  all_patients_symptoms, all_patients_diagnostics, 4)
    print("Recommended symptom to test for Maria:",rec_maria)
    rec_jaspal = recommend_symptom_to_test(jaspal,  all_patients_symptoms, all_patients_diagnostics, 4)
    print("Recommended symptom to test for Japsal:",rec_jaspal)


    # Now doing the same tests on a much larger data set
    print("*"*80)
    print("Now with the larger patient data set...")
    
    all_patients_symptoms, all_patients_diagnostics = read_data_from_file('/Users/blanchette/COMP204/HW3/medicalData.txt')    
    
    # Testing the similarity_to_patients function    
    print("*"*80)
    sim_list = similarity_to_patients(yang, all_patients_symptoms)
    print("similarity list for Yang is ",sim_list)
    sim_list = similarity_to_patients(maria, all_patients_symptoms)
    print("Similarity list for Maria is ",sim_list)
    sim_list = similarity_to_patients(jaspal, all_patients_symptoms)
    print("Similarity list for Jaspal is ",sim_list)
    
    # Testing the most_similar_patients function
    print("*"*80)    
    best_matches_yang = most_similar_patients(yang, all_patients_symptoms,100)
    print("Yang's best matches:",best_matches_yang)
    best_matches_maria = most_similar_patients(maria, all_patients_symptoms,100)
    print("Maria's best matches:",best_matches_maria)
    best_matches_jaspal = most_similar_patients(jaspal, all_patients_symptoms,100)
    print("Jaspal's best matches:",best_matches_jaspal)
    
    # Testing the diagnostics_from_symptoms function
    print("*"*80)       
    diagnostics_yang = diagnostics_from_symptoms(yang, all_patients_symptoms, all_patients_diagnostics, 100)
    print("Diagnostics for Yang:", diagnostics_yang)
    diagnostics_maria = diagnostics_from_symptoms(maria, all_patients_symptoms, all_patients_diagnostics, 100)
    print("Diagnostics for Maria:",diagnostics_maria)
    diagnostics_jaspal = diagnostics_from_symptoms(jaspal, all_patients_symptoms, all_patients_diagnostics, 100)
    print("Diagnostics for Jaspal:",diagnostics_jaspal)
    
    # Testing the pretty_print_diagnostics function
    print("*"*80)
    print("Patient Yang:")
    pretty_print_diagnostics(diagnostics_yang)
    print("Patient Maria:")
    pretty_print_diagnostics(diagnostics_maria)
    print("Patient Jaspal:")
    pretty_print_diagnostics(diagnostics_jaspal)
    
    # Testing the recommend_symptom_to_test function
    print("*"*80)
    rec_yang = recommend_symptom_to_test(yang, all_patients_symptoms, all_patients_diagnostics, 100)
    print("Recommended symptom to test for Yang:",rec_yang)
    rec_maria = recommend_symptom_to_test(maria,  all_patients_symptoms, all_patients_diagnostics, 100)
    print("Recommended symptom to test for Maria:",rec_maria)
    rec_jaspal = recommend_symptom_to_test(jaspal,  all_patients_symptoms, all_patients_diagnostics, 100)
    print("Recommended symptom to test for Japsal:",rec_jaspal)
    
    
my_test()