from bus_generic import Bus

class PayBus(Bus):
    def __init__(self, price=2):
        Bus.__init__(self)
        self.cost_of_ticket = price # cost of a ticket
        self.cash = 0         # the total cash onboard
        
    def load(self, waiting_line):
        number_boarding = Bus.load(self, waiting_line)
        self.cash += number_boarding * self.cost_of_ticket
        return number_boarding
    
    def __str__(self):         
        return Bus.__str__(self)+\
               "\nCost of ticket: " + str(self.cost_of_ticket) +\
               "; Cash collected: " + str(self.cash)
    

stm_bus = PayBus(2)
stm_bus.load([3,4,5,2,6,2,3])
print("Cash = ",stm_bus.cash) # Prints Cash = 10

print(stm_bus)
#Bus at station 3 contains passengers [3, 4, 5, 2, 6]
#Cost of ticket: 2; Cash collected: 10

generic_bus = Bus()
stm_bus = PayBus(2)

print(generic_bus)
# Bus at station 0 contains passengers []

print(stm_bus)
#Bus at station 0 contains passengers []
#Cost of ticket: 2; Cash collected: 0

generic_bus.load([4,2,5,3,6,4,2,4])
print(generic_bus)
# Bus at station 0 contains passengers [4, 2, 5, 3, 6]

stm_bus.load([4,2,5,3,6,4,2,4])
print(stm_bus)
#Bus at station 0 contains passengers [4, 2, 5, 3, 6]
#Cost of ticket: 2; Cash collected: 10

