
class Probabilistic_diagnostic:
    def __init__(self):
        self.prob = {}
    

    def count_diagnostics(self,patient_set):
        """
        Args:
            self: The object on which the method is called 
            patient_set: A set of patients
        Returns:
            Nothing
        Behavior:
            Sets the prob attribute to the observed disease frequency among patient_set
        """         
        self.prob = {}
        for p in patient_set:
            diag = p.diagnostic
            if self.prob.get(diag)==None:
                self.prob[diag] = 1
            else:
                self.prob[diag] += 1
    
        nb_patients = len(patient_set)
        for k in self.prob.keys():
            self.prob[k] /= nb_patients

    def pretty_print_diagnostics(self):  
        """
        Args:
            self: The object on which the method is called 
        Returns:
            Nothing
        Behavior:
            Prints the Probabilistic diagnostic prettily
        """          
        def getKey1(item):
            return item[1]        
        
        sorted_diag = sorted(self.prob.items(), key=getKey1, reverse=True)
        for diagnotic, p in sorted_diag:
            print(f'{diagnotic[0:10]:11}{int(100*p):3d}%')


    def diagnostic_clarity(self):
        """
        Args:
            self: The object on which the method is called 
        Returns:
            Clarity of diagnostic (float)
        """        
        return max(self.prob.values())
        
